"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function promisify(original, settings) {
    return function (...args) {
        let target;
        if (settings && settings.thisArg) {
            target = settings.thisArg;
        }
        else if (settings) {
            target = settings;
        }
        // Return the promisified function
        return new Promise(function (resolve, reject) {
            // Append the callback bound to the context
            args.push(function callback(err, ...values) {
                if (err) {
                    return reject(err);
                }
                return resolve(values[0]);
            });
            // Call the function
            original.apply(target, args);
        });
    };
}
exports.promisify = promisify;
;
//# sourceMappingURL=promisify.js.map